package reachable;

import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Queue;
import java.util.Set;

public class Reachability {

	public static Set<String> reachableSet(Map<String, List<List<String>>> rules, String start) {
		Queue<String> reachableQueue = new LinkedList<>();
		Set<String> reachable = new HashSet<>();
		reachable.add(start);
		reachableQueue.add(start);
		reachableSet(rules, reachableQueue, reachable);
		return reachable;
	}

	private static void reachableSet(Map<String, List<List<String>>> rules, Queue<String> reachableQueue,
			Set<String> reachable) {
		String premise = reachableQueue.poll();
		if (premise != null) {
			for (List<String> conclusio : rules.get(premise)) {
				for (String c : conclusio) {
					if (rules.keySet().contains(c) && !reachable.contains(c)) {
						reachableQueue.add(c);
					}
					reachable.add(c);
				}
			}
			reachableSet(rules, reachableQueue, reachable);
		}
	}
}
